The only value for the option is "nullok", so make it more readable.
Also don't die if we get NULL from the conversation function.
diff -uNr Linux-PAM-0.75/modules/pam_unix/unix_chkpwd.c Linux-PAM-0.75/modules/pam_unix/unix_chkpwd.c
--- Linux-PAM-0.75/modules/pam_unix/unix_chkpwd.c	Tue Oct  2 13:57:49 2001
+++ Linux-PAM-0.75/modules/pam_unix/unix_chkpwd.c	Tue Oct  2 14:39:48 2001
@@ -81,7 +81,7 @@
 	(void) sigaction(SIGQUIT, &action, NULL);
 }
 
-static int _unix_verify_password(const char *name, const char *p, int opt)
+static int _unix_verify_password(const char *name, const char *p, int nullok)
 {
 	struct passwd *pwd = NULL;
 	struct spwd *spwdent = NULL;
@@ -128,11 +128,13 @@
 	}
 
 	if (strlen(salt) == 0)
-		return (opt == 0) ? UNIX_FAILED : UNIX_PASSED;
+		return (nullok == 0) ? UNIX_FAILED : UNIX_PASSED;
+	if (p == NULL)
+		return UNIX_FAILED;
 
 	/* the moment of truth -- do we agree with the password? */
 	retval = UNIX_FAILED;
-	if (!strncmp(salt, "$1$", 3)) {
+	if (strncmp(salt, "$1$", 3) == 0) {
 		pp = Goodcrypt_md5(p, salt);
 		if (strcmp(pp, salt) == 0) {
 			retval = UNIX_PASSED;
@@ -181,7 +183,7 @@
 {
 	char pass[MAXPASS + 1];
 	char option[8];
-	int npass, opt;
+	int npass, nullok;
 	int force_failure = 0;
 	int retval = UNIX_FAILED;
 	char *user;
@@ -234,9 +236,9 @@
 	} else {
 		option[7] = '\0';
 		if (strncmp(option, "nullok", 8) == 0)
-			opt = 1;
+			nullok = 1;
 		else
-			opt = 0;
+			nullok = 0;
 	}
 
 	/* read the password from stdin (a pipe from the pam_unix module) */
@@ -255,13 +257,13 @@
 		if (npass == 0) {
 			/* the password is NULL */
 
-			retval = _unix_verify_password(user, NULL, opt);
+			retval = _unix_verify_password(user, NULL, nullok);
 
 		} else {
 			/* does pass agree with the official one? */
 
 			pass[npass] = '\0';	/* NUL terminate */
-			retval = _unix_verify_password(user, pass, opt);
+			retval = _unix_verify_password(user, pass, nullok);
 
 		}
 	}
